#ifndef MP_H_
#define MP_H_
#include "Bit.h"
#include "structs.h"
void initMP (int num_genomes,
	     struct genome_struct *genomes,
	     struct genome_struct *labels, int num_genes);

int MPScore (struct tNode *root);

int compact (int state, int loc, int num_genomes);
void Sequence2MP (struct genome_struct *genomes,
		  struct genome_struct *labels, char *fname,
		  int num_genomes, int num_genes);

void cleanMP (struct genome_struct *genomes,
	      struct genome_struct *labels, int num_genomes, int num_genes);

void clearInternal (struct tNode *tree, struct genome_struct *labels,
		    int num_genes, int num_genomes);
/*add internal genomes from labels, and clean the state to all 0*/

void initialize_tree_MPME (int COND, struct tNode *tree, struct tNode *tpool,
			   struct genome_struct *labels, struct qNode *queue,
			   struct adj_struct *adj_list,
			   struct adj_struct *adj_pool, int **weights,
			   int *stack, int *degree, int *otherEnd,
			   intpair_t * neighbors, edge_t * edges,
			   int *incycle, int *outcycle, int *pred, int *succ,
			   int *code, int *decode, int num_genes,
			   int num_genomes, int inittspsolver, int thresh,
			   int CIRCULAR);

void firstPass (struct tNode *tree, int num_genes, int num_genomes);
/*first pass of the MP procedure*/

void secondPass (struct tNode *tree, int num_genes, int num_genomes);
/*second pass of the MP procedure*/

void printMP (struct tNode *tree, int num_genes, int num_genomes);

void sequence2state (struct genome_struct *genome, int num_genes);

void setMPmatrix (int **distmatrix, struct genome_struct *genomes,
		  int num_genes, int num_genomes, distmem_t * distmem,
		  int CIRCULAR);

int hammingMP (struct genome_struct *g1, struct genome_struct *g2,
	       int num_genes);
#endif
