#include "MSA.h"
#include "labeltree.h"
#include <stdio.h>
#include "stdlib.h"
#include "math.h"
#include "string.h"
#define printAlign
//#define DEBUG1
extern int PAoutput;
extern int UseMatrix;
extern int PairMethod;
extern int PairG;
extern int PairGX;
extern short **stateTrans;
extern short **coTrans;
extern char *median3;		// Final median
extern cell **U;
extern cell **D;
extern cell **I;
extern char *revA;
extern char *revB;
extern char *revC;
extern char *Aout;
extern char *Bout;
extern char *Cout;
extern char *h_A, *h_B, *h_C;
extern int *aa;
extern int *bb;
extern int *cc;
extern int m_length;
extern char *m_segment, *a_segment, *b_segment, *c_segment;
extern int rec_count;
extern char ***minChar;
extern int ***minValue;
extern int *gapPos;
extern char *AA, *BB;

int flip = 0;

void
AffineTAMSAscoreProMPAM (char *A, char *B, char *C, int X, int Y, int Z,
			 int **cost, int s1, int s2)
{
  char median;
  short i, j, k, l, medianL = 0;
  short pI, pJ, pK;
  short m, n, minJ = 0, minK = 0, st1, st2;
  short g = PairG, gx = PairGX;
  int first, second;
  short leg1 = s1, leg2 = s2;
  int min, len;

  rec_count++;
  if (X == 0)
    {
      s1 = convertState (s1);
      s2 = convertState (s2);
#ifdef DEBUG1
      printf ("AlignTwo (%d,%d,%d), (s1:s2, %d:%d) ", X, Y, Z, s1, s2);
#endif
      alignTwo (B, C, Y, Z, cost, bb, cc, s1, s2);
      for (i = 0; i < strlen (m_segment); i++)
	{
	  Aout[m_length] = '-';
	  Bout[m_length] = b_segment[i];
	  Cout[m_length] = c_segment[i];
	  median3[m_length++] = m_segment[i];
	}
      return;
    }
  else if (Y == 0)
    {
      s1 = convertState (s1);
      s2 = convertState (s2);
#ifdef DEBUG1
      printf ("AlignTwo (%d,%d,%d), (s1:s2, %d:%d) ", X, Y, Z, s1, s2);
#endif
      if (s1 < 20 && s1 != -1)
	s1 = s1 + 8;
      else if (s1 == 23)	/* reverse between MDI and DMI */
	s1 = 24;
      else if (s1 == 24)
	s1 = 23;

      if (s2 < 20 && s2 != -1)
	s2 = s2 + 8;
      else if (s2 == 23)
	s2 = 24;
      else if (s2 == 24)
	s2 = 23;

      alignTwo (A, C, X, Z, cost, aa, cc, s1, s2);
      for (i = 0; i < strlen (m_segment); i++)
	{
	  Aout[m_length] = b_segment[i];
	  Bout[m_length] = '-';
	  Cout[m_length] = c_segment[i];
	  median3[m_length++] = m_segment[i];
	}
      return;
    }
  else if (Z == 0)
    {
#ifdef DEBUG1
      printf ("AlignTwo (%d,%d,%d), (s1:s2, %d:%d) ", X, Y, Z, s1, s2);
#endif
      alignTwo (B, A, Y, X, cost, bb, aa, s1, s2);
      for (i = 0; i < strlen (m_segment); i++)
	{
	  Bout[m_length] = b_segment[i];
	  Aout[m_length] = c_segment[i];
	  Cout[m_length] = '-';
	  median3[m_length++] = m_segment[i];
	}
      return;
    }
  else if (X == 1)
    {
      /* if input X ==1, no need to do the combine states.  
       * instead, we can compute the alignment directly, because
       * it conly has two layers. */
      //s1 = convertState (s1);
      flip = 1;
      scoreThree (C, B, A, Z, Y, 1, cost, cc, bb, aa, s1);
      min = MAX;
      for (l = 0; l < 26; l++)
	{
	  if (U[Z][Y].i[l] < min)
	    {
	      min = U[Z][Y].i[l];
	      st1 = l;
	      median = U[Z][Y].m[l];
	    }
	}
      i = Z;
      j = Y;
      k = X;
      len = 0;
      while (i > 0 || j > 0 || k > 0)
	{			/* j = Y, k = Z */
	  //    st1 = convertState (st1);
	  switch (st1)
	    {
	      /* by feng need to check? */
	    case 0:
	      pI = i - 1;
	      pJ = j - 1;
	      pK = k - 1;
	      a_segment[len] = C[i - 1];
	      b_segment[len] = B[j - 1];
	      c_segment[len] = A[k - 1];
	      break;
	    case 2:
	      pI = i - 1;
	      pJ = j - 1;
	      pK = k;
	      a_segment[len] = C[i - 1];
	      b_segment[len] = B[j - 1];
	      c_segment[len] = '-';
	      break;
	    case 5:
	      pI = i - 1;
	      pJ = j;
	      pK = k - 1;
	      a_segment[len] = C[i - 1];
	      b_segment[len] = '-';
	      c_segment[len] = A[k - 1];
	      break;
	    case 8:
	    case 9:
	    case 10:
	    case 11:
	    case 12:
	      pI = i - 1;
	      pJ = j;
	      pK = k;
	      a_segment[len] = C[i - 1];
	      b_segment[len] = '-';
	      c_segment[len] = '-';
	      break;
	    case 13:
	    case 14:
	    case 15:
	      pI = i;
	      pJ = j - 1;
	      pK = k - 1;
	      a_segment[len] = '-';
	      b_segment[len] = B[j - 1];
	      c_segment[len] = A[k - 1];
	      break;
	    case 16:
	    case 17:
	    case 18:
	    case 19:
	    case 20:
	      pI = i;
	      pJ = j - 1;
	      pK = k;
	      a_segment[len] = '-';
	      b_segment[len] = B[j - 1];
	      c_segment[len] = '-';
	      break;
	    case 21:
	    case 22:
	    case 23:
	    case 24:
	    case 25:
	      pI = i;
	      pJ = j;
	      pK = k - 1;
	      a_segment[len] = '-';
	      b_segment[len] = '-';
	      c_segment[len] = A[k - 1];
	      break;
	    default:
	      fprintf (stderr, "wrong in the X==1 situation.\n");
	      fprintf (stderr, "case number is %d.\n", st1);
	      exit (-1);
	      break;
	    }
	  if (k == 0)
	    {
	      m_segment[len++] = D[i][j].m[st1];
	      st1 = D[i][j].from[st1];
	    }
	  else
	    {
	      m_segment[len++] = U[i][j].m[st1];
	      st1 = U[i][j].from[st1];
	    }
#ifdef DEBUG1
	  printf ("median is %c, (%d, %d, %d), st1 is %d.\n",
		  m_segment[len - 1], pI, pJ, pK, st1);
#endif
	  i = pI;
	  j = pJ;
	  k = pK;
	}
      m_segment[len] = '\0';
      a_segment[len] = '\0';
      b_segment[len] = '\0';
      c_segment[len] = '\0';
      revString (m_segment);
      revString (a_segment);
      revString (b_segment);
      revString (c_segment);
      for (i = 0; i < strlen (m_segment); i++)
	{
	  Aout[m_length] = c_segment[i];
	  Bout[m_length] = b_segment[i];
	  Cout[m_length] = a_segment[i];
	  median3[m_length++] = m_segment[i];
	}
      flip = 0;
#ifdef DEBUG1
      printf ("X=%d, Y=%d, Z=%d", X, Y, Z);
      printf ("median segment: %s.\n", m_segment);
#endif
    }
  else
    {
      i = X / 2;
      revNewString (&A[i], X - i, revA);
      revNewString (B, Y, revB);
      revNewString (C, Z, revC);
      scoreThree (C, B, A, Z, Y, i, cost, cc, bb, aa, s1);
      for (k = 0; k <= Z; k++)
	{
	  for (j = 0; j <= Y; j++)
	    {
	      for (l = 0; l < 26; l++)
		{
		  I[k][j].i[l] = U[k][j].i[l];
		  I[k][j].m[l] = U[k][j].m[l];
//                I[k][j].from[l] = U[k][j].from[l];
		}
	    }
	}
      scoreThree (revC, revB, revA, Z, Y, X - i, cost, cc, bb, aa, s2);
      /* combine two parts */
      min = MAX;
      for (k = 0; k <= Z; k++)
	{
	  for (j = 0; j <= Y; j++)
	    {
	      for (m = 0; m < 26; m++)
		{
		  for (n = 0; n < 26; n++)
		    {
		      if (m == 1 || m == 3 || m == 4 || m == 6 || m == 7
			  || m == 14 || m == 15)
			{
			  continue;
			}
		      if (n == 1 || n == 3 || n == 4 || n == 6 || n == 7
			  || n == 14 || n == 15)
			{
			  continue;
			}
		      if ((m == 10 && n == 10) || (m == 18 & n == 18)
			  || (m == 23 && n == 23) ||
			  (m == 11 && n == 11) || (m == 19 & n == 19)
			  || (m == 24 && n == 24))
			{
			  if (I[k][j].i[m] + U[Z - k][Y - j].i[n] -
			      2 * (g - gx) < min)
			    //  && I[k][j].i[m] + U[Z - k][Y - j].i[n] -
			    //  2 * (g - gx) >= 0)
			    {
			      min =
				I[k][j].i[m] + U[Z - k][Y - j].i[n] -
				2 * (g - gx);
			      minJ = j;
			      minK = k;
			      median = I[k][j].m[m];
			      st1 = m;
			      st2 = n;
			      first = I[k][j].i[m];
			      second = U[Z - k][Y - j].i[n];
			    }

			}

		      else if (coTrans[m][n] < 4)
			{
			  if (I[k][j].i[m] + U[Z - k][Y - j].i[n] -
			      coTrans[m][n] * (g - gx) < min)
			    // && I[k][j].i[m] + U[Z - k][Y - j].i[n] -
			    // coTrans[m][n] * (g - gx) >= 0)
			    {
			      min =
				I[k][j].i[m] + U[Z - k][Y - j].i[n] -
				coTrans[m][n] * (g - gx);
			      minJ = j;
			      minK = k;
			      median = I[k][j].m[m];
			      st1 = m;
			      st2 = n;
			      first = I[k][j].i[m];
			      second = U[Z - k][Y - j].i[n];
			    }
			}	// end of if valid state
		    }		// end of n
		}
	    }
	}
#ifdef DEBUG1
      printf
	("(%d, %d, %d)/(%d, %d, %d) %d=%d+%d, S1S2 %d:%d, median %c\n",
	 X, Y, Z, i, minJ, minK, min, first, second, st1, st2, median);
#endif
      //  if (i == 1 && minJ == Y && minK == Z) // solve infinite loop
      //  the key here is to switch states!
      //if (median == 'X')
//      fprintf (stderr, "Error in the recursive call!\n");
      if (i == 1)
	{
	  switch (st1)
	    {
	      /* s1 to pass through the beginning state of the alignment
	         don't care for the ending, pick up the min */
	    case 0:
	    case 1:
	      if (minJ - 1 > 0 || minK - 1 > 0)
		AffineTAMSAscoreProMPAM (A, B, C, 0, minJ - 1, minK - 1,
					 cost, s1, -1);
	      Aout[m_length] = A[0];
	      Bout[m_length] = B[minJ - 1];
	      Cout[m_length] = C[minK - 1];
	      median3[m_length++] = median;
	      break;
	    case 2:
	    case 3:
	    case 4:
	      AffineTAMSAscoreProMPAM (A, B, C, 1, minJ - 1, minK - 1,
				       cost, s1, -1);
	      Aout[m_length] = '-';
	      Bout[m_length] = B[minJ - 1];
	      Cout[m_length] = C[minK - 1];
	      median3[m_length++] = median;
	      break;
	    case 5:
	    case 6:
	    case 7:
	      if (minJ > 0 || minK - 1 > 0)
		AffineTAMSAscoreProMPAM (A, B, C, 0, minJ, minK - 1, cost,
					 s1, -1);
	      Aout[m_length] = A[0];
	      Bout[m_length] = '-';
	      Cout[m_length] = C[minK - 1];
	      median3[m_length++] = median;
	      break;
	    case 8:
	    case 9:
	    case 10:
	    case 11:
	    case 12:
	      AffineTAMSAscoreProMPAM (A, B, C, 1, minJ, minK - 1, cost,
				       s1, -1);
	      Aout[m_length] = '-';
	      Bout[m_length] = '-';
	      Cout[m_length] = C[minK - 1];
	      median3[m_length++] = median;
	      break;
	    case 13:
	    case 14:
	    case 15:
	      if (minJ - 1 > 0 || minK > 0)
		AffineTAMSAscoreProMPAM (A, B, C, 0, minJ - 1, minK, cost,
					 s1, -1);
	      Aout[m_length] = A[0];
	      Bout[m_length] = B[minJ - 1];
	      Cout[m_length] = '-';
	      median3[m_length++] = median;
	      break;
	    case 16:
	    case 17:
	    case 18:
	    case 19:
	    case 20:
	      AffineTAMSAscoreProMPAM (A, B, C, 1, minJ - 1, minK, cost,
				       s1, -1);
	      Aout[m_length] = '-';
	      Bout[m_length] = B[minJ - 1];
	      Cout[m_length] = '-';
	      median3[m_length++] = median;
	      break;
	    case 21:
	    case 22:
	    case 23:
	    case 24:
	    case 25:
	      if (minK > 0 || minJ > 0)
		AffineTAMSAscoreProMPAM (A, B, C, 0, minJ, minK, cost,
					 s1, -1);
	      Aout[m_length] = A[0];
	      Bout[m_length] = '-';
	      Cout[m_length] = '-';
	      median3[m_length++] = median;
	      break;
	    default:
	      break;
	    }
	}

      // median3[m_length++] = A[0];
      else
	AffineTAMSAscoreProMPAM (A, B, C, i, minJ, minK, cost, leg1, st1);
      if (X - i > 0 || Y - minJ > 0 || Z - minK > 0)
	AffineTAMSAscoreProMPAM (&A[i], &B[minJ], &C[minK], X - i,
				 Y - minJ, Z - minK, cost, st2, leg2);
    }
}

void
scoreThree (char *A, char *B, char *C, int X, int Y, int Z,
	    int **cost, int *aa, int *bb, int *cc, int state)
{
  int i = 0, j = 0, k = 0, l = 0, z = 0;
//  short sI, sJ, sK;
  int r, s, t;
  int g = PairG;
  int gx = PairGX;
  int pI, pJ, pK;
  int currentCost;
  int from = -1;
  char tempMedian = '_';
  cell **tempMatrix = NULL;

  int min = MAX;
  // int temp = MAX;

  if (X > 0)
    convertArray (A, aa, X);
  if (Y > 0)
    convertArray (B, bb, Y);
  if (Z > 0)
    convertArray (C, cc, Z);

  /* init */
  for (i = 0; i <= X; i++)
    {
      for (j = 0; j <= Y; j++)
	{
	  for (l = 0; l < 26; l++)
	    {
	      U[i][j].i[l] = MAX;
	      // U[i][j].i[l] = 0;
	      U[i][j].m[l] = 'X';
	      U[i][j].from[l] = -1;
	      D[i][j].i[l] = MAX;
	      D[i][j].m[l] = 'X';
	      D[i][j].from[l] = -1;
	    }
	}
    }
//       for (i = 0; i < 26; i++) 
  switch (state)
    {
    case -1:
      U[0][0].i[0] = 0;
      for (i = 1; i <= X; i++)
	{
	  U[i][0].i[9] = g + (i - 1) * gx;
	  U[i][0].m[9] = '-';
	  U[i][0].from[9] = 9;
	  U[i][0].i[8] = 2 * (g + (i - 1) * gx);
	  U[i][0].m[8] = A[i - 1];
	  U[i][0].from[8] = 8;
	}
      for (j = 1; j <= Y; j++)
	{
	  U[0][j].i[17] = g + (j - 1) * gx;
	  U[0][j].m[17] = '-';
	  U[0][j].from[17] = 17;
	  U[0][j].i[16] = 2 * (g + (j - 1) * gx);
	  U[0][j].m[16] = B[j - 1];
	  U[0][j].from[16] = 16;
	}
      break;
    case 0:
      if (aa[0] == bb[0] || aa[0] == cc[0])
	{
	  if (bb[0] == cc[0])
	    D[1][1].i[0] = 0;
	  else
	    D[1][1].i[0] = cost[bb[0]][cc[0]];
	  D[1][1].m[0] = A[0];
	}
      else if (bb[0] == cc[0])
	{
	  D[1][1].i[0] = cost[aa[0]][cc[0]];
	  D[1][1].m[0] = B[0];
	}
      else
	{
	  D[1][1].i[0] = cost[bb[0]][cc[0]] + cost[aa[0]][cc[0]];
	  D[1][1].m[0] = A[0];
	}
      D[1][1].from[0] = 0;
      break;
    case 2:
      U[1][1].i[state] = g + cost[aa[0]][bb[0]];
      U[1][1].m[state] = A[0];
      break;
    case 5:
      D[1][0].i[state] = g + cost[aa[0]][cc[0]];
      D[1][0].m[state] = A[0];
      break;
    case 8:
      U[1][0].i[state] = 2 * g;
      U[1][0].m[state] = A[0];
      break;
    case 9:
    case 10:
    case 11:
    case 12:
      U[1][0].i[state] = g;
      U[1][0].m[state] = '-';
      for (i = 1; i <= X; i++)
	{
	  U[i][0].i[state] = g + (i - 1) * gx;
	  U[i][0].m[state] = '-';
	  U[i][0].from[state] = state;
	}
      break;
    case 13:
      D[0][1].i[state] = g + cost[bb[0]][cc[0]];
      D[0][1].m[state] = B[0];
      break;
    case 16:
      U[0][1].i[state] = 2 * g;
      U[0][1].m[state] = B[0];
      break;
    case 17:
    case 18:
    case 19:
    case 20:
      U[0][1].i[state] = g;
      U[0][1].m[state] = '-';
      for (j = 1; j <= Y; j++)
	{
	  U[0][j].i[state] = g + (j - 1) * gx;
	  U[0][j].m[state] = '-';
	  U[0][j].from[state] = state;
	}
      break;
    case 21:
      D[0][0].i[state] = 2 * g;
      D[0][0].m[state] = C[0];
      break;
    case 22:
    case 23:
    case 24:
    case 25:
      D[0][0].i[state] = g;
      D[0][0].m[state] = '-';
      break;
    default:
      fprintf (stderr, "state not valid.\n");
      exit (-1);
      break;
    }
  if (state == -1 || state == 2 || state == 8
      || state == 9 || state == 10 || state == 11 || state == 12
      || state == 16 || state == 17 || state == 18 || state == 19
      || state == 20)
    {
      for (i = 1; i <= X; i++)
	{
	  for (j = 1; j <= Y; j++)
	    {
	      min = MAX;
	      r = aa[i - 1];
	      s = bb[j - 1];
	      /*start from U[1][1].i[2], don't need to update the rest of U[1][1] */
	      if (i == 1 && j == 1 && state == 2)
		continue;
	      else
		{
		  for (l = 2; l < 26; l++)
		    {
		      if (l == 0 || l == 1 || l == 3 || l == 4 || l == 5
			  || l == 6 || l == 7 || l == 13 || l == 14
			  || l == 15 || l > 20)
			continue;
		      switch (l)
			{
			case 2:
			  currentCost = cost[r][s] + g;
			  tempMedian = A[i - 1];
			  pI = i - 1;
			  pJ = j - 1;
			  break;
			case 8:
			  tempMedian = A[i - 1];
			  currentCost = 2 * g;
			  pI = i - 1;
			  pJ = j;
			  break;
			case 9:
			case 10:
			case 11:
			case 12:
			  currentCost = g;
			  tempMedian = '-';
			  pI = i - 1;
			  pJ = j;
			  break;
			case 16:
			  pI = i;
			  pJ = j - 1;
			  currentCost = 2 * g;
			  tempMedian = B[j - 1];
			  break;
			case 17:
			case 18:
			case 19:
			case 20:
			  currentCost = g;
			  tempMedian = '-';
			  pJ = j - 1;
			  pI = i;
			  break;

			default:
			  fprintf (stderr, "wrong in U space. case %d.\n", l);
			  exit (-1);
			  break;
			}
		      for (z = 0; z < 21; z++)
			{
			  /* if ( z == 1 || z == 3 || z == 4 || 
			     || z == 6 || z == 7 || z == 13 || z == 14
			     || z == 15 || z > 20)
			     continue;
			   */
			  if (z == 1 || z == 3 || z == 4 || z == 6 || z == 7
			      || z == 14 || z == 15)
			    continue;
			  if (stateTrans[z][l] < 4)
			    {	/* transition is valid */
			      if (U[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    U[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			}
		      U[i][j].i[l] = min;
		      U[i][j].from[l] = from;
		      U[i][j].m[l] = tempMedian;
		      min = MAX;
		    }		// l loop
		}		// end of if ... else 
	    }			// j loop
	}			// i loop
    }				// end if if case
  for (k = 1; k <= Z; k++)
    {
      /* problem here: need to update D[1,0] */
      if (state == -1)
	{
	  D[0][0].i[22] = g + (k - 1) * gx;
	  D[0][0].m[22] = '-';
	  D[0][0].from[22] = 22;
	  D[0][0].i[21] = 2 * (g + (k - 1) * gx);
	  D[0][0].m[21] = C[k - 1];
	  D[0][0].from[21] = 21;
	}
      else if (state == 22 || state == 23 || state == 24 || state == 25)
	{
	  D[0][0].i[state] = g + (k - 1) * gx;
	  D[0][0].m[state] = '-';
	  D[0][0].from[state] = state;
	}
      if (k != 1 || state != 0)
	/* when k==1, state =0, we don't need to computer the 0,j, or i,0
	   to update X axis and Y axis */
	{
	  i = 0;
	  for (j = 1; j <= Y; j++)
	    {
	      if (k == 1 && j == 1 && state == 13)
		continue;
	      min = MAX;
	      s = bb[j - 1];
	      t = cc[k - 1];
	      for (l = 13; l < 26; l++)
		{
		  if (l == 14 || l == 15)
		    continue;
		  switch (l)
		    {
		    case 13:
		      currentCost = g + cost[s][t];
		      tempMedian = B[j - 1];
		      pI = i;
		      pJ = j - 1;
		      pK = k - 1;
		      break;
		    case 16:
		      pI = i;
		      pJ = j - 1;
		      pK = k;
		      currentCost = 2 * g;
		      tempMedian = B[j - 1];
		      break;
		    case 17:
		    case 18:
		    case 19:
		    case 20:
		      pI = i;
		      pJ = j - 1;
		      pK = k;
		      currentCost = g;
		      tempMedian = '-';
		      break;
		    case 21:
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      currentCost = 2 * g;
		      tempMedian = C[k - 1];
		      break;
		    case 22:
		    case 23:
		    case 24:
		    case 25:
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      currentCost = g;
		      tempMedian = '-';
		      break;
		    default:
		      break;
		    }
		  for (z = 0; z < 26; z++)
		    {
		      if (z == 1 || z == 3 || z == 4 || z == 6 || z == 7
			  || z == 14 || z == 15)
			{
			  continue;
			}

		      if (stateTrans[z][l] < 4)
			{
			  if (pK < k)
			    {
			      if (U[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    U[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			  else
			    {
			      if (D[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    D[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			}
		    }
		  D[0][j].i[l] = min;
		  D[0][j].from[l] = from;
		  D[0][j].m[l] = tempMedian;
		  min = MAX;
		}
	    }			// end of j loop j axis and x = 0;
	  j = 0;
	  for (i = 1; i <= X; i++)
	    {
	      if (k == 1 && i == 1 && state == 5)
		continue;
	      min = MAX;
	      r = aa[i - 1];
	      t = cc[k - 1];
	      for (l = 0; l < 26; l++)
		{
		  /*
		     if (l == 1 || l == 3 || l == 4 || l == 6 || l == 7
		     || l == 14 || l == 15)
		     {
		     continue;
		     }
		     if (D[i][0].i[l] < MAX)
		     continue;
		   */
		  if (l < 5 || l == 6 || l == 7 || (l > 12 && l < 21))
		    continue;
		  switch (l)
		    {
		    case 5:
		      currentCost = cost[r][t] + g;
		      tempMedian = A[i - 1];
		      pI = i - 1;
		      pJ = j;
		      pK = k - 1;
		      break;
		    case 8:
		      tempMedian = A[i - 1];
		      currentCost = 2 * g;
		      pI = i - 1;
		      pJ = j;
		      pK = k;
		      break;
		    case 9:
		    case 10:
		    case 11:
		    case 12:
		      currentCost = g;
		      tempMedian = '-';
		      pI = i - 1;
		      pJ = j;
		      pK = k;
		      break;
		    case 21:
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      currentCost = 2 * g;
		      tempMedian = C[k - 1];
		      break;
		    case 22:
		    case 23:
		    case 24:
		    case 25:
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      currentCost = g;
		      tempMedian = '-';
		      break;
		    default:
		      break;
		    }
		  for (z = 0; z < 26; z++)
		    {
		      if (z == 1 || z == 3 || z == 4 || z == 6 || z == 7
			  || z == 14 || z == 15)
			{
			  continue;
			}
		      if (stateTrans[z][l] < 4)
			{
			  if (pK < k)
			    {
			      if (U[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    U[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			  else
			    {
			      if (D[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    D[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			}
		    }
		  D[i][0].i[l] = min;
		  D[i][0].from[l] = from;
		  D[i][0].m[l] = tempMedian;
		  min = MAX;
		}
	    }			// end of i loop 
	}
      for (i = 1; i <= X; i++)
	{
	  for (j = 1; j <= Y; j++)
	    {
	      min = MAX;
	      r = aa[i - 1];
	      s = bb[j - 1];
	      t = cc[k - 1];
	      if (k == 1 && i == 1 && j == 1 && state == 0)
		continue;

	      for (l = 0; l < 26; l++)
		{
		  if (l == 1 || l == 3 || l == 4 || l == 6 || l == 7
		      || l == 14 || l == 15)
		    continue;
		  switch (l)
		    {
		    case 0:
		      /*
		         if (r == s || r == t)
		         {
		         if (s == t)
		         currentCost = 0;
		         else
		         currentCost = cost[0][1];
		         tempMedian = A[i - 1];
		         }
		         else if (s == t)
		         {
		         currentCost = cost[0][1];
		         tempMedian = B[j - 1];
		         }
		         else
		         {
		         currentCost = 2 * cost[0][1];
		         tempMedian = A[i - 1];
		         }
		       */
		      currentCost = minValue[r][s][t];
		      tempMedian = minChar[r][s][t];
		      /*
		         printf ("1, 2, 3, %d, %d, %d\n", cost[r][s], cost[r][t],
		         cost[s][t]);
		         printf
		         ("r, s, t, A, B, C, min, matrix, %d, %d, %d, %c, %c, %c, %d, %d\n",
		         r, s, t, A[i - 1], B[j - 1], C[k - 1],
		         currentCost, minValue[r][s][t]);
		       */
		      if (tempMedian == 'X')
			{
			  printf ("Median char is X");
			}
		      pI = i - 1;
		      pJ = j - 1;
		      pK = k - 1;
		      break;
		    case 2:
		      currentCost = cost[r][s] + g;
		      tempMedian = A[i - 1];
		      pI = i - 1;
		      pJ = j - 1;
		      pK = k;
		      break;
		    case 5:
		      currentCost = cost[r][t] + g;
		      tempMedian = A[i - 1];
		      pI = i - 1;
		      pJ = j;
		      pK = k - 1;
		      break;
		    case 8:
		      tempMedian = A[i - 1];
		      currentCost = 2 * g;
		      pI = i - 1;
		      pJ = j;
		      pK = k;
		      break;
		    case 9:
		    case 10:
		    case 11:
		    case 12:
		      currentCost = g;
		      tempMedian = '-';
		      pI = i - 1;
		      pJ = j;
		      pK = k;
		      break;
		    case 13:
		      currentCost = g + cost[s][t];
		      tempMedian = B[j - 1];
		      pI = i;
		      pJ = j - 1;
		      pK = k - 1;
		      break;
		    case 16:
		      pI = i;
		      pJ = j - 1;
		      pK = k;
		      currentCost = 2 * g;
		      tempMedian = B[j - 1];
		      break;
		    case 17:
		    case 18:
		    case 19:
		    case 20:
		      currentCost = g;
		      tempMedian = '-';
		      pI = i;
		      pJ = j - 1;
		      pK = k;
		      break;
		    case 21:
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      currentCost = 2 * g;
		      tempMedian = C[k - 1];
		      break;
		    case 22:
		    case 23:
		    case 24:
		    case 25:
		      currentCost = g;
		      tempMedian = '-';
		      pI = i;
		      pJ = j;
		      pK = k - 1;
		      break;
		    default:
		      fprintf (stderr, "Error in score three function.\n");
		      exit (-1);
		      break;
		    }
		  for (z = 0; z < 26; z++)
		    {
		      if (z == 1 || z == 3 || z == 4 || z == 6 || z == 7
			  || z == 14 || z == 15)
			continue;
		      if (stateTrans[z][l] < 4)
			{	/* transition is valid */
			  if (pK < k)
			    {
			      if (U[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    U[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			  else
			    {
			      if (D[pI][pJ].i[z] + currentCost -
				  stateTrans[z][l] * (g - gx) < min)
				{
				  min =
				    D[pI][pJ].i[z] + currentCost -
				    stateTrans[z][l] * (g - gx);
				  from = z;
				}
			    }
			}
		    }
		  D[i][j].i[l] = min;
		  D[i][j].from[l] = from;
		  D[i][j].m[l] = tempMedian;
		  min = MAX;
		}		// L matrix
	    }			// J
	}			// I
      tempMatrix = U;
      U = D;
      D = tempMatrix;
      if (Z == 1 && flip == 1)
	break;
      else
	{
	  for (i = 0; i <= X; i++)
	    {
	      for (j = 0; j <= Y; j++)
		{
		  for (l = 0; l < 26; l++)
		    {
		      D[i][j].i[l] = MAX;
		      D[i][j].m[l] = 'X';
		      D[i][j].from[l] = -1;
		    }		// l loop
		}		// j loop
	    }			// i loop
	}			// k loop
    }
  return;
}

void
alignTwo (char *B, char *C, int Y, int Z, int **cost, int *bb, int *cc,
	  int start, int end)
{
  short i = 0, j = 0, k = 0, l = 0, z = 0;
  short s, t;
  short g = PairG;
  short gx = PairGX;
  short pJ, pK;
  short currentCost;
  short from = -1, pr, len = 0;
  char tempMedian = '_';

  int min = MAX;

  if (Y > 0)
    convertArray (B, bb, Y);
  if (Z > 0)
    convertArray (C, cc, Z);

  /* init */
  for (i = 0; i <= Y; i++)
    {
      for (j = 0; j <= Z; j++)
	{
	  for (l = 0; l < 26; l++)
	    {
	      U[i][j].i[l] = MAX;
	      U[i][j].m[l] = 'X';
	      U[i][j].from[l] = -1;
	    }
	}
    }
  switch (start)
    {
    case -1:
      U[0][0].i[0] = 0;
      for (i = 1; i <= Y; i++)
	{
	  U[i][0].i[16] = 2 * (g + (i - 1) * gx);
	  U[i][0].m[16] = B[i - 1];
	  U[i][0].from[16] = 16;
	  U[i][0].i[17] = g + (i - 1) * gx;
	  U[i][0].m[17] = '-';
	  U[i][0].from[17] = 17;
	}
      for (j = 1; j <= Z; j++)
	{
	  U[0][j].i[21] = 2 * (g + (j - 1) * gx);
	  U[0][j].m[21] = C[j - 1];
	  U[0][j].from[21] = 21;
	  U[0][j].i[22] = g + (j - 1) * gx;
	  U[0][j].m[22] = '-';
	  U[0][j].from[22] = 22;
	}
      break;
    case 13:
      U[1][1].i[13] = g + cost[bb[0]][cc[0]];
      U[1][1].from[13] = 13;
      U[1][1].m[13] = B[0];
      break;
    case 16:
      for (i = 1; i <= Y; i++)
	{
	  U[i][0].i[start] = 2 * (g + (i - 1) * gx);
	  U[i][0].m[start] = B[i - 1];
	  U[i][0].from[start] = start;
	}
      break;
    case 17:
    case 18:
    case 19:
    case 20:
      for (i = 1; i <= Y; i++)
	{
	  U[i][0].i[start] = g + (i - 1) * gx;
	  U[i][0].m[start] = '-';
	  U[i][0].from[start] = start;
	}
      break;
    case 21:
      for (j = 1; j <= Z; j++)
	{
	  U[0][j].i[start] = 2 * (g + (j - 1) * gx);
	  U[0][j].m[start] = C[j - 1];
	  U[0][j].from[start] = start;
	}
      break;
    case 22:
    case 23:
    case 24:
    case 25:
      for (j = 1; j <= Z; j++)
	{
	  U[0][j].i[start] = g + (j - 1) * gx;
	  U[0][j].m[start] = '-';
	  U[0][j].from[start] = start;
	}
      break;
    default:
      fprintf (stderr, "case number not valid in aligntwo.\n");
      exit (-1);
    }
  for (j = 1; j <= Y; j++)
    {
      for (k = 1; k <= Z; k++)
	{
	  if (j == 1 && k == 1 && start == 13)
	    continue;
	  min = MAX;
	  s = bb[j - 1];
	  t = cc[k - 1];
	  for (l = 13; l < 26; l++)
	    {
	      switch (l)
		{
		case 13:
		  currentCost = g + cost[s][t];
		  tempMedian = B[j - 1];
		  pJ = j - 1;
		  pK = k - 1;
		  break;
		case 14:
		case 15:
		  pJ = j - 1;
		  pK = k - 1;
		  currentCost = 2 * g;
		  tempMedian = '-';
		  break;
		case 16:
		  pJ = j - 1;
		  pK = k;
		  currentCost = 2 * g;
		  tempMedian = B[j - 1];
		  break;
		case 21:
		  pJ = j;
		  pK = k - 1;
		  currentCost = 2 * g;
		  tempMedian = C[k - 1];
		  break;
		case 17:
		case 18:
		case 19:
		case 20:
		  currentCost = g;
		  tempMedian = '-';
		  pJ = j - 1;
		  pK = k;
		  break;
		case 22:
		case 23:
		case 24:
		case 25:
		  currentCost = g;
		  tempMedian = '-';
		  pK = k - 1;
		  pJ = j;
		  break;
		default:
		  break;
		}

	      for (z = 0; z < 26; z++)
		{
		  if (stateTrans[z][l] < 4)
		    {		/* transition is valid */
		      if (U[pJ][pK].i[z] + currentCost -
			  stateTrans[z][l] * (g - gx) < min)
			{
			  min =
			    U[pJ][pK].i[z] + currentCost -
			    stateTrans[z][l] * (g - gx);
			  from = z;
			}
		    }
		}
	      U[j][k].i[l] = min;
	      U[j][k].from[l] = from;
	      U[j][k].m[l] = tempMedian;
	      min = MAX;
	    }

	}
    }
  m_segment[0] = '\0';
  b_segment[0] = '\0';
  c_segment[0] = '\0';
  if (end == -1)
    {
      for (l = 13; l < 26; l++)
	{
	  if (U[Y][Z].i[l] < min)
	    {
	      pr = l;
	      min = U[Y][Z].i[l];
	      from = U[Y][Z].from[l];
	      // m_segment[len++] = U[Y][Z].m[l];
	    }
	}
    }
  else
    {
      pr = end;
      min = U[Y][Z].i[end];
      from = U[Y][Z].from[end];

    }
//  j --;
//  k --;
  j = Y;
  k = Z;
  while (j > 0 || k > 0)
    {				/* j = Y, k = Z */
      switch (pr)
	{
	  /* by feng need to check? */
	case 13:
	case 14:
	case 15:
	  pJ = j - 1;
	  pK = k - 1;
	  b_segment[len] = B[j - 1];
	  c_segment[len] = C[k - 1];
	  break;
	case 16:
	case 17:
	case 18:
	case 19:
	case 20:
	  pJ = j - 1;
	  pK = k;
	  b_segment[len] = B[j - 1];
	  c_segment[len] = '-';
	  break;
	case 21:
	case 22:
	case 23:
	case 24:
	case 25:
	  pJ = j;
	  pK = k - 1;
	  b_segment[len] = '-';
	  c_segment[len] = C[k - 1];
	  break;
	default:
	  break;
	}
      m_segment[len++] = U[j][k].m[pr];
      pr = U[j][k].from[pr];
      j = pJ;
      k = pK;
    }
  m_segment[len] = '\0';
  b_segment[len] = '\0';
  c_segment[len] = '\0';
  revString (m_segment);
  revString (b_segment);
  revString (c_segment);
#ifdef DEBUG1
  printf ("\n");
  for (i = 0; i < len; i++)
    printf ("%c", b_segment[i]);
  printf ("\n");
  for (i = 0; i < len; i++)
    printf ("%c", c_segment[i]);
  printf ("\n");
  printf ("%s.        score is %d\n", m_segment, min);
#endif
}

int
pairscore (char *A, char *B, int X, int Y, int *aa, int *bb,
	   char *AA, char *BB, cell ** pairSpace, int **cost)
{
  int i, j, g, gx, M;
  int min = -MAX;
  int max = MAX;
  int output, pos = 0;
  int **whichDist;
  cell **tempStruct = NULL;
  int ham = 0;
  //For debugging purpose.
  int phylipDist = 0;
  //int           tempX, tempY;
  int r = -1, s = -1;
  int tempcounter;
  int temp = 0, temp2 = 0;
  tempStruct = pairSpace;
  g = PairG;
  gx = PairGX;
  whichDist = cost;
  for (i = 0; i <= X; i++)
    {
      for (j = 0; j <= Y; j++)
	{
	  if (PairMethod == PAM250Dist)
	    {
	      tempStruct[i][j].i[0] = min;
	      tempStruct[i][j].i[1] = min;
	      tempStruct[i][j].i[2] = min;
	    }
	  else
	    {
	      tempStruct[i][j].i[0] = max;
	      tempStruct[i][j].i[1] = max;
	      tempStruct[i][j].i[2] = max;
	    }
	  tempStruct[i][j].m[0] = '_';
	  tempStruct[i][j].i[6] = min;
	}
    }
  /*
   * the following procedure is to transfer string A and B to string of
   * integers, which corresponds to their position in Lisan's Matrix,
   * so that when we wanted to check the value of pair A and C, we know
   * its value is cost(0, 1) or cost(aa[0], bb[0])
   */
  convertArray (A, aa, X);
  convertArray (B, bb, Y);
  /* Below we will calculate the alignment score with pam 250 distance */
  if (PairMethod == PAM250Dist)
    {
      tempStruct[0][0].i[0] = 0;
      tempStruct[0][0].i[1] = 0;
      tempStruct[0][0].i[2] = 0;
      for (i = 1; i <= X; i++)
	{
	  tempStruct[i][0].i[1] = g + (i - 1) * gx;
	  tempStruct[i][0].i[0] = -MAX;
	  tempStruct[i][0].i[2] = -MAX;
	  tempStruct[i][0].i[4] = 1;
	}
      for (i = 1; i <= Y; i++)
	{
	  tempStruct[0][i].i[2] = g + (i - 1) * gx;
	  tempStruct[0][i].i[0] = -MAX;
	  tempStruct[0][i].i[1] = -MAX;
	  tempStruct[0][i].i[5] = 2;
	}
      /* M value */
      for (i = 1; i <= X; i++)
	{
	  for (j = 1; j <= Y; j++)
	    {
	      r = aa[i - 1];
	      s = bb[j - 1];
	      if (tempStruct[i - 1][j - 1].i[0] + whichDist[r][s] > min)
		{
		  min = tempStruct[i - 1][j - 1].i[0] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 0;
		}
	      if (tempStruct[i - 1][j - 1].i[1] + whichDist[r][s] > min)
		{
		  min = tempStruct[i - 1][j - 1].i[1] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 1;
		}
	      if (tempStruct[i - 1][j - 1].i[2] + whichDist[r][s] > min)
		{
		  min = tempStruct[i - 1][j - 1].i[2] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 2;
		}
	      tempStruct[i][j].i[0] = min;
	      M = min;
	      min = -MAX;
	      /* Ix value */
	      /* need to check if r = 20 or s = s ??? */
	      if (tempStruct[i - 1][j].i[0] + g >
		  tempStruct[i - 1][j].i[1] + gx)
		{
		  tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[0] + g;
		  tempStruct[i][j].i[4] = 0;
		}
	      else
		{
		  tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[1] + gx;
		  tempStruct[i][j].i[4] = 1;
		}

	      /* Iy value */
	      if (tempStruct[i][j - 1].i[0] + g >
		  tempStruct[i][j - 1].i[2] + gx)
		{
		  tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[0] + g;
		  tempStruct[i][j].i[5] = 0;
		}
	      else
		{
		  tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[2] + gx;
		  tempStruct[i][j].i[5] = 2;
		}
	    }
	}

    }
  /*
   * we calculating the minimal distance with edit or mpam the
   * procedure is the same as above, only at each step we take the
   * minimal instead of maximum We use .i[0] to present M, .i[0] to
   * represent Ix, .i[2] to represent Iy.
   */
  if ((PairMethod == MPAM) || (PairMethod == EDIT)
      || (PairMethod == PROTDIST))
    {
      tempStruct[0][0].i[0] = 0;
      tempStruct[0][0].i[1] = 0;
      tempStruct[0][0].i[2] = 0;

      if (A[0] != 'X')
	tempStruct[1][0].i[1] = g;
      else
	tempStruct[1][0].i[1] = 0;
      tempStruct[1][0].i[0] = MAX;
      tempStruct[1][0].i[2] = MAX;
      tempStruct[1][0].i[4] = 1;

      if (B[0] != 'X')
	tempStruct[0][1].i[2] = g;
      else
	tempStruct[0][1].i[2] = 0;
      tempStruct[0][1].i[0] = MAX;
      tempStruct[0][1].i[1] = MAX;
      tempStruct[0][1].i[5] = 2;

      for (i = 2; i <= X; i++)
	{
	  if (A[i - 1] != 'X')
	    tempStruct[i][0].i[1] = tempStruct[i - 1][0].i[1] + gx;
	  else
	    tempStruct[i][0].i[1] = tempStruct[i - 1][0].i[1];
	  tempStruct[i][0].i[0] = MAX;
	  tempStruct[i][0].i[2] = MAX;
	  tempStruct[i][0].i[4] = 1;
	}
      for (i = 2; i <= Y; i++)
	{
	  if (B[i - 1] != 'X')
	    tempStruct[0][i].i[2] = tempStruct[0][i - 1].i[2] + gx;
	  else
	    tempStruct[0][i].i[2] = tempStruct[0][i - 1].i[2];
	  tempStruct[0][i].i[0] = MAX;
	  tempStruct[0][i].i[1] = MAX;
	  tempStruct[0][i].i[5] = 2;
	}
      /* M value */
      for (i = 1; i <= X; i++)
	{
	  for (j = 1; j <= Y; j++)
	    {
	      r = aa[i - 1];
	      s = bb[j - 1];
	      if (tempStruct[i - 1][j - 1].i[0] + whichDist[r][s] < max)
		{
		  max = tempStruct[i - 1][j - 1].i[0] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 0;
		}
	      if (tempStruct[i - 1][j - 1].i[1] + whichDist[r][s] < max)
		{
		  max = tempStruct[i - 1][j - 1].i[1] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 1;
		}
	      if (tempStruct[i - 1][j - 1].i[2] + whichDist[r][s] < max)
		{
		  max = tempStruct[i - 1][j - 1].i[2] + whichDist[r][s];
		  tempStruct[i][j].i[3] = 2;
		}
	      tempStruct[i][j].i[0] = max;
	      M = max;
	      max = MAX;
	      /* Ix value */
	      if (r != 20)
		{
		  if (tempStruct[i - 1][j].i[0] + g <
		      tempStruct[i - 1][j].i[1] + gx)
		    {
		      tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[0] + g;
		      tempStruct[i][j].i[4] = 0;
		    }
		  else
		    {
		      tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[1] + gx;
		      tempStruct[i][j].i[4] = 1;
		    }
		}
	      else
		{
		  if (tempStruct[i - 1][j].i[0] < tempStruct[i - 1][j].i[1])
		    {
		      tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[0];
		      tempStruct[i][j].i[4] = 0;
		    }
		  else
		    {
		      tempStruct[i][j].i[1] = tempStruct[i - 1][j].i[1];
		      tempStruct[i][j].i[4] = 1;
		    }
		}

	      /* Iy value */
	      if (s != 20)
		{
		  if (tempStruct[i][j - 1].i[0] + g <
		      tempStruct[i][j - 1].i[2] + gx)
		    {
		      tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[0] + g;
		      tempStruct[i][j].i[5] = 0;
		    }
		  else
		    {
		      tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[2] + gx;
		      tempStruct[i][j].i[5] = 2;
		    }
		}
	      else
		{
		  if (tempStruct[i][j - 1].i[0] < tempStruct[i][j - 1].i[2])
		    {
		      tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[0];
		      tempStruct[i][j].i[5] = 0;
		    }
		  else
		    {
		      tempStruct[i][j].i[2] = tempStruct[i][j - 1].i[2];
		      tempStruct[i][j].i[5] = 2;
		    }
		}
	    }
	}
    }
  /* traceback begins from here. */
  if (PairMethod == PROTDIST)
    output = 1000 + tempStruct[X][Y].i[0];
  else if (PairMethod == MPAM)
    {
      if (tempStruct[X][Y].i[0] < tempStruct[X][Y].i[1])
	output = tempStruct[X][Y].i[0];
      else
	output = tempStruct[X][Y].i[1];
      if (output > tempStruct[X][Y].i[2])
	output = tempStruct[X][Y].i[2];
    }
  else
    {
      if (tempStruct[X][Y].i[0] > tempStruct[X][Y].i[1])
	output = tempStruct[X][Y].i[0];
      else
	output = tempStruct[X][Y].i[1];
      if (output < tempStruct[X][Y].i[2])
	output = tempStruct[X][Y].i[2];
    }
  if (PAoutput)
    {
      pairSpace = tempStruct;
      i = X;
      j = Y;
      tempcounter = 0;
      if ((PairMethod == MPAM) || (PairMethod == EDIT)
	  || (PairMethod == PROTDIST))
	{			// get the minimum value
	  if (pairSpace[i][j].i[0] < pairSpace[i][j].i[1])
	    {
	      temp = 0;
	      max = pairSpace[i][j].i[0];
	      temp2 = pairSpace[i][j].i[3];
	    }
	  else
	    {
	      temp = 1;
	      max = pairSpace[i][j].i[1];
	      temp2 = pairSpace[i][j].i[4];
	    }
	  if (pairSpace[i][j].i[2] < max)
	    {
	      temp = 2;
	      temp2 = pairSpace[i][j].i[5];
	    }
	}
      else
	{			// max
	  if (pairSpace[i][j].i[0] > pairSpace[i][j].i[1])
	    {
	      temp = 0;
	      max = pairSpace[i][j].i[0];
	      temp2 = pairSpace[i][j].i[3];
	    }
	  else
	    {
	      temp = 1;
	      max = pairSpace[i][j].i[1];
	      temp2 = pairSpace[i][j].i[4];
	    }
	  if (pairSpace[i][j].i[2] > max)
	    {
	      temp = 2;
	      temp2 = pairSpace[i][j].i[5];
	    }
	}
      while ((i != 0) || (j != 0))
	{
	  //fprintf(stderr, "(%d,%d)", i,j);
	  if (temp == 0)
	    {
	      i--;
	      j--;
	      AA[tempcounter] = A[i];
	      BB[tempcounter] = B[j];
	    }
	  else if (temp == 1)
	    {
	      i--;
	      AA[tempcounter] = A[i];
	      BB[tempcounter] = '_';
	    }
	  else if (temp == 2)
	    {
	      j--;
	      AA[tempcounter] = '_';
	      BB[tempcounter] = B[j];
	    }
	  else
	    {
	      fprintf (stderr,
		       "Something is wrong in the pair length  procedure!!\n");
	      fprintf (stderr, "pairSpace[%d][%d].i[6] is %d.\n", i, j,
		       pairSpace[i][j].i[6]);
	      exit (-1);
	    }
	  temp = temp2;
	  tempcounter++;	// counter is the length of alignment!
	  if (temp2 == 0)
	    {
	      temp2 = pairSpace[i][j].i[3];
	    }
	  else if (temp2 == 1)
	    {
	      temp2 = pairSpace[i][j].i[4];
	    }
	  else if (temp2 == 2)
	    {
	      temp2 = pairSpace[i][j].i[5];
	    }
	  else
	    {
	      fprintf (stderr, "error in pairwise trackback!");
	      exit (-1);
	    }
	}
      AA[tempcounter] = '\0';
      BB[tempcounter] = '\0';
      revString (AA);
      revString (BB);
      //printf ("%s,\n%s.  score is %d.\n", AA, BB, output);

      /* rewrite A sequence with X */
      for (i = 0; i < strlen (AA); i++)
	{
	  if (AA[i] == '_')
	    {
	      A[i] = 'X';
	      gapPos[pos++] = i;
	    }
	  else
	    A[i] = AA[i];
	}
      A[i] = '\0';
      for (i = 0; i < strlen (BB); i++)
	{
	  if (BB[i] == '_')
	    B[i] = 'X';
	  else
	    B[i] = BB[i];
	}
      B[i] = '\0';
    }
  gapPos[pos] = -1;
  if (PairMethod == MPAM)
    return output;
  else if (PairMethod == EDIT)
    return ham;
  else if (PairMethod == PROTDIST)
    return phylipDist;
  else
    return output;
}



void
setALmatrix (int **distmatrix,
	     struct genome_struct *genomes, int num_genes,
	     int num_genomes, cell ** pairSpace,
	     int CIRCULAR, int **cost, int *aa, int *bb, char *AA, char *BB)
{
  int i, j;
  for (i = 0; i < num_genomes; i++)
    {
      distmatrix[i][i] = 0;
      for (j = i + 1; j < num_genomes; j++)
	{
	  distmatrix[i][j] = distmatrix[j][i] =
	    pairscore ((genomes + i)->genes, (genomes + j)->genes,
		       (genomes + i)->num_chars,
		       (genomes + j)->num_chars, aa, bb, AA, BB,
		       pairSpace, cost);
	}
    }
}


void
cleanCell (cell *** score, struct genome_struct *gen1,
	   struct genome_struct *gen2, struct genome_struct *gen3)
{
  //fprintf(stderr, "Entering cleanCell ...\n");
  int i, j, k, X, Y, Z;
  X = gen1->num_chars;
  Y = gen2->num_chars;
  Z = gen3->num_chars;
  for (i = 0; i <= X; i++)
    {

      for (j = 0; j <= Y; j++)
	{

	  for (k = 0; k <= Z; k++)
	    {
	      /*
	       * score[i][j][k].A[0] = 0;
	       * score[i][j][k].A[1] = 0;
	       * score[i][j][k].A[2] = 0;
	       * score[i][j][k].i[0] = MAX;
	       * score[i][j][k].i[1] = MAX;
	       * score[i][j][k].i[2] = MAX;
	       * score[i][j][k].i[3] = MAX;
	       * score[i][j][k].i[5] = MAX;
	       * score[i][j][k].i[6] = MAX;
	       * score[i][j][k].m[0] = '_';
	       * score[i][j][k].A[6] = 0;
	       */
	    }
	}
    }
}
void
condenseGap (char *answer, int *len)
{
  int i, j = 0, g = 0;
  //int temp = *len;
  j = 0;
  for (i = 0; i < *len; i++)
    {
      if (answer[i] == '-' || answer[i] == 'X')
	{
	  g++;
	}
      else
	{
	  answer[j] = answer[i];
	  j++;
	}
    }
//  for (i = j; i < j + g; i++)
  //   answer[i] = ' ';
  answer[j] = '\0';
  *len = j;
}

void
convertArray (char *A, int *aa, int length)
{
  /* change an array to the position on the sub matrix */
  int i;
  for (i = 0; i < length; i++)
    {
      switch (A[i])
	{
	case 'A':
	  aa[i] = A[i] - 65;
	  break;
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	  aa[i] = A[i] - 66;
	  break;
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	  aa[i] = A[i] - 67;
	  break;
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	  aa[i] = A[i] - 68;
	  break;
	case 'V':
	case 'W':
	  aa[i] = A[i] - 69;
	  break;
	case 'Y':
	  aa[i] = A[i] - 70;
	  break;
	case 'X':
	  aa[i] = 20;
	  break;
	default:
	  fprintf (stderr,
		   "\nError in the convert function, \n In sequence %s \nPosition %d %c, %d is not protein data!\n",
		   A, i, A[i], A[i]);
	  fprintf (stderr, "Program exit upon error.\n");
	  exit (-1);
	  break;
	}
    }
}
void
revString (char *A)
{
  int i, len;
  char t;

  len = strlen (A);
  for (i = 0; i < len / 2; i++)
    {
      t = A[i];
      A[i] = A[len - i - 1];
      A[len - i - 1] = t;
    }
}
void
revNewString (char *A, int len, char *revA)
{
  int i;

  for (i = 0; i < len; i++)
    {
      revA[i] = A[len - i - 1];
    }
  revA[len] = '\0';
#ifdef progress
  printf ("Reverse String of %s is %s.\n", A, revA);
#endif

}

int
convertState (int in)
{
  int state;
  switch (in)
    {
    case -1:
    case 0:
    case 5:
    case 16:
    case 17:
    case 20:
      state = in;
      break;
    case 2:
      state = 13;
      break;
    case 8:
      state = 21;
      break;
    case 9:
      state = 22;
      break;
    case 10:
      state = 24;
      break;
    case 11:
      state = 23;
      break;
    case 12:
      state = 25;
      break;
    case 13:
      state = 2;
      break;
    case 18:
      state = 19;
      break;
    case 19:
      state = 18;
      break;
    case 21:
      state = 8;
      break;
    case 22:
      state = 9;
      break;
    case 23:
      state = 11;
      break;
    case 24:
      state = 10;
      break;
    case 25:
      state = 12;
      break;
    default:
      fprintf (stderr, "something wrong in the convert state.\n");
      exit (-1);
    }
  return state;
}

int
scan_pair (char *A, char *B, int **cost)
{
  int i, score, state;
  int g, gx;
  int X, Y;


  g = PairG;
  gx = PairGX;
  X = strlen (A);
  Y = strlen (B);

  if (X != Y)
    printf ("In scan_pair function, %d, %d.\n", X, Y);
//  printf("From scan_pair:\n%s\n%s\n",  A, B);
  for (i = 0; i < X; i++)
    {
      if (A[i] == '.')
	A[i] = 'X';
      if (B[i] == '.')
	B[i] = 'X';
    }
  if (X > 0)
    convertArray (A, aa, X);
  if (Y > 0)
    convertArray (B, bb, Y);
  score = 0;
  state = 0;
  for (i = 0; i < X; i++)
    {
      if (A[i] != B[i])
	{
	  if (A[i] == 'X' && state != 1)
	    {
	      score += g;
	      state = 1;
	    }
	  else if (A[i] == 'X' && state == 1)
	    score += gx;
	  else if (B[i] == 'X' && state != 2)
	    {
	      score += g;
	      state = 2;
	    }
	  else if (B[i] == 'X' && state == 2)
	    score += gx;
	  else
	    {
	      score += cost[aa[i]][bb[i]];
	      state = 0;
	    }

	}
      else
	{
	  if (A[i] != 'X')
	    {
	      score += cost[aa[i]][bb[i]];
	      state = 0;
	    }
	}
    }
  //     printf("Pair align score = %d\n",  score);
  for (i = 0; i < X; i++)
    {
      if (A[i] == 'X')
	A[i] = '.';
      if (B[i] == 'X')
	B[i] = '.';
    }

  return score;

}

void
h_median (char *A, char *B, char *C, int X, int Y, int Z, cell ** pairSpace,
	  int **costDist)
{
  int ab, ac, bc;
  int i, dist, st;
  for (i = 0; i < X; i++)
    h_A[i] = A[i];
  h_A[i] = '\0';
  for (i = 0; i < Y; i++)
    h_B[i] = B[i];
  h_B[i] = '\0';
  for (i = 0; i < Z; i++)
    h_C[i] = C[i];
  h_C[i] = '\0';
  PAoutput = 0;
  ab = pairscore (h_A, h_B, X, Y, aa, bb, AA, BB, pairSpace, costDist);
  bc = pairscore (h_B, h_C, Y, Z, bb, cc, AA, BB, pairSpace, costDist);
  ac = pairscore (h_A, h_C, X, Z, aa, cc, AA, BB, pairSpace, costDist);
  if (ab < bc)
    {
      if (ab < ac)
	st = 0;			// ab is min 
      else
	st = 1;			// ac is min
    }
  else
    {
      if (bc < ac)
	st = 2;			// bc is min
      else
	st = 1;			// ac is min
    }
  PAoutput = 1;
  switch (st) {
	  case 0:
   pairscore (h_A, h_B, X, Y, aa, bb, AA, BB, pairSpace, costDist);
    pairscore (h_B, h_C, strlen (h_B), Z, bb, cc, AA, BB, pairSpace,
	       costDist);
    break;
	  case 1:
   pairscore (h_A, h_C, X, Z, aa, cc, AA, BB, pairSpace, costDist);
    pairscore (h_C, h_B, strlen (h_C), Y, cc, bb, AA, BB, pairSpace,
	       costDist);
    break;
	  case 2:
   pairscore (h_B, h_C, Y, Z, bb, cc, AA, BB, pairSpace, costDist);
    pairscore (h_C, h_A, strlen (h_C), X, cc, aa, AA, BB, pairSpace,
	       costDist);
    break;
	  default:
    fprintf(stderr, "wrong in Heuristic median.\n");
    break;
  }
//  printf ("\nA:%s\nB:%s\nC:%s\n", h_A, h_B, h_C);
//  printf ("\nA:%s\nB:%s\nC:%s\nDist=%d.\n", h_A, h_B, h_C, dist);
  /* The result is already stored in AA and BB in correct order */
  
  for (i = 0; i < strlen (h_B); i++)
    {
      if (AA[i] == '_')
	{
	  shiftString (h_A, i);
	}
    }
//  printf ("\nA:%s\nB:%s\nC:%s\n.", h_A, h_B, h_C);
  PAoutput = 0;
  /* below lines are used to vote median */
  convertArray (h_A, aa, strlen (h_A));
  convertArray (h_B, bb, strlen (h_B));
  convertArray (h_C, cc, strlen (h_C));
  for (i = 0; i < strlen (h_A); i++)
    {
      if ((h_A[i] == 'X' && h_B[i] == 'X') ||
	  (h_A[i] == 'X' && h_C[i] == 'X') ||
	  (h_C[i] == 'X' && h_B[i] == 'X'))
	median3[i] = 'X';
      else
	median3[i] = minChar[aa[i]][bb[i]][cc[i]];
    }
  m_length = i;
  median3[i] = '\0';

  return;

}
