#include "structs.h"

void
TBR (struct tNode *tree, struct tNode *tpool, int num_genomes)
{
  int npos, epos, i;		/* n the cut, e the add */

  struct tNode *nparent;
  struct tNode *eparent;

  npos = 2 + rand () % (2 * num_genomes - 4);	/* should be 1+... */
  epos = 2 + rand () % (2 * num_genomes - 4);
  while (!validEdge (tpool, npos, epos))
    {
      npos = 2 + rand () % (2 * num_genomes - 4);
      epos = 2 + rand () % (2 * num_genomes - 4);
    }

  nparent = tpool[npos].parent;
  eparent = tpool[epos].parent;
/*
    printf("n=%p  np=%p         e=%p  ep=%p\n", &tpool[npos], nparent,
            &tpool[epos], eparent);

    printf("npl=%p npr=%p       epl=%p epr=%p\n",
            nparent->lChild, nparent->rChild,
            eparent->lChild, eparent->rChild);
    printf("nl=%p nr=%p         el=%p er=%p\n",
            tpool[npos].lChild, tpool[npos].rChild,
            tpool[epos].lChild, tpool[epos].rChild);

    printf("npp=%p epp=%p\n",
            nparent==NULL?NULL:nparent->parent, 
            eparent==NULL?NULL:eparent->parent);
            */
  if (nparent->parent == NULL)
    {				/* cut under root */

    }
  else if (nparent->parent->lChild == nparent)
    {
      /* is left child of parent */
      if (nparent->lChild == &tpool[npos])
	{
	  nparent->parent->lChild = tpool[npos].parent->rChild;
	}
      else
	nparent->parent->lChild = tpool[npos].parent->lChild;
    }
  else if (nparent->parent->rChild == nparent)
    {
      if (nparent->lChild == &tpool[npos])
	{
	  nparent->parent->rChild = tpool[npos].parent->rChild;
	}
      else
	nparent->parent->rChild = tpool[npos].parent->lChild;
    }
  else
    {
      printf ("You should not be here\n");
      exit (-1);

    }

  nparent->rChild = &tpool[npos];	/* make sure the node is the right */

  if (eparent == NULL)
    {
      eparent->lChild = nparent;
    }
  else if (eparent->lChild == &tpool[epos])
    {
      eparent->lChild = nparent;
    }
  else if (eparent->rChild == &tpool[epos])
    eparent->rChild = nparent;
  else
    {
      printf ("You should not be here 2\n");
      exit (-1);
    }
  nparent->parent = eparent;
  nparent->lChild = &tpool[epos];
  tpool[epos].parent = nparent;

  return;


}

int
validEdge (struct tNode *tpool, int npos, int epos)
{
  struct tNode *p;
  if (epos == npos || tpool[npos].parent == &tpool[epos]
      || tpool[epos].parent == &tpool[npos]
      || tpool[epos].parent == tpool[npos].parent)
    return 0;

  /* we don't want epos be a subtree of npos */
  p = tpool[epos].parent;
  while (p != NULL)
    {
      if (p == &tpool[npos])
	return 0;
      p = p->parent;
    }

  return 1;
}
