#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "condense.h"

#define NEWCODE

typedef struct chain_s
{
  int adj;
  struct chain_s *next;
} chain_t;

void
condense_genes (struct genome_struct *genome_list,
		int num_genomes, int *num_genes, int CIRCULAR,
		int *succ, int *decode)
{

  printf ("Should not be called\n");
  exit (-1);

  return;
}

void
print_tree_genomes_uncondensed (struct tNode *tree, int num_genes,
				int *condense_succ,
				int *condense_decode, int orig_num_genes)
{
  int i;

  int *succ, *decode;

  succ = condense_succ + orig_num_genes;
  decode = condense_decode + orig_num_genes;

  if (tree == NULL)
    return;
  fprintf (outfile, "Genome %4d:", tree->tag);
  for (i = 0; i < tree->genome->num_chars; i++)
    {
      fprintf (outfile, "%c", tree->genome->genes[i]);
    }
  fprintf (outfile, "\n");
  print_tree_genomes_uncondensed (tree->lChild, num_genes,
				  condense_succ, condense_decode,
				  orig_num_genes);
  print_tree_genomes_uncondensed (tree->rChild, num_genes,
				  condense_succ, condense_decode,
				  orig_num_genes);
  return;
}


void
print_tree_nexus (struct tNode *tree)
{

  if (tree == NULL)
    return;

  if (tree->parent == NULL)
    {
      fprintf (outfile, "\n");
      if (tree->lChild != NULL)
	{

	  fprintf (outfile, "(%s:%d,", tree->genome->gnamePtr,
		   *(tree->sc_lChild));

	  print_tree_nexus (tree->lChild);
	  fprintf (outfile, ":0);");
	}
      fprintf (outfile, "\n\n");
      return;
    }

  if (tree->lChild != NULL)
    {
      fprintf (outfile, "(");
      print_tree_nexus (tree->lChild);
      fprintf (outfile, ":%d,", *(tree->sc_lChild));
      print_tree_nexus (tree->rChild);
      fprintf (outfile, ":%d)", *(tree->sc_rChild));
    }
  else
    {
      fprintf (outfile, "%s", tree->genome->gnamePtr);
    }

  return;
}

void
print_tree_nexus_noscore (char *TreeString, struct tNode *tree)
{
  if (tree == NULL)
    return;

  if (tree->parent == NULL)
    {
      if (tree->lChild != NULL)
	{

	  sprintf (TreeString, "(%s,", tree->genome->gnamePtr);

	  print_tree_nexus_noscore (TreeString, tree->lChild);
	}
      strcat (TreeString, ")\0");
      return;
    }

  if (tree->lChild != NULL)
    {
      strcat (TreeString, "(");
      print_tree_nexus_noscore (TreeString, tree->lChild);
      strcat (TreeString, ",");
      print_tree_nexus_noscore (TreeString, tree->rChild);
      strcat (TreeString, ")");

    }
  else
    {
      strcat (TreeString, tree->genome->gnamePtr);
    }

  return;
}

void
print_tree_uncondensed (struct tNode *tree, int num_genes,
			int *condense_succ,
			int *condense_decode, int orig_num_genes)
{

  print_tree_nexus (tree);

  print_tree_genomes_uncondensed (tree, num_genes,
				  condense_succ, condense_decode,
				  orig_num_genes);
  return;
}
