#include "structs.h"
#include "labeltree.h"
#include "convert.h"
#include "lk_main.h"
#include "bbtsp.h"
#include "binencode.h"
#include "invdist.h"
#include "condense3.h"
#include "cheaptsp.h"
#include "inversion_median.h"
#include "inversion_median_alberto.h"
#include "correction.h"
#include "inversion_median.h"
#include "sorting_reversal_median.h"
#include "Bit.h"
#include "MSA.h"
#include "transfer.h"
#define DOOLITTLE 0
//#define M_debug
//#define checkSeq
//extern cell ***scoreCell;
extern int PAoutput;
extern int HEUR;
extern int **costDist;
extern cell **pairSpace;
extern int *aa;
extern int *bb;
extern int *cc;
extern char *AA;
extern char *BB;
extern char *median3, *Aout, *Bout, *Cout;
extern int Delta;
extern int *printG;
extern int UseMatrix;
extern int PairMethod;
extern int PairG;
extern int PairGX;
extern int m_length;
extern int *gapPos;
extern int scan_score;
int row = 0;
void
printedgescores (struct tNode *tree)
{
  if (tree == NULL)
    return;
  if (tree->lChild)
    {
      fprintf (outfile, "tree_score: edge %p is worth %4d\n",
	       tree->sc_lChild, *(tree->sc_lChild));
      fflush (outfile);
      printedgescores (tree->lChild);
    }
  if (tree->rChild)
    {
      fprintf (outfile, "tree_score: edge %p is worth %4d\n",
	       tree->sc_rChild, *(tree->sc_rChild));
      fflush (outfile);
      printedgescores (tree->rChild);
    }
  return;
}

int
iterate_over_tree (int COND, struct tNode *tree, int num_genes,
		   int num_genomes, int tspsolver, int thresh, int score,
		   struct adj_struct *adj_list, struct adj_struct *adj_pool,
		   intpair_t * neighbors, int *stack, int *incycle,
		   int *outcycle, int **weights, int *degree, int *otherEnd,
		   edge_t * edges, struct tNode *tpool,
		   struct genome_struct *labels, int *pred1, int *pred2,
		   int *picked, int *decode, char *genes, int CIRCULAR,
		   int distmethod, distmem_t * distmem, int correction)
{
  int best_so_far = score;
  struct tNode *condnode1 = NULL, *condnode2 = NULL, *condnode3 =
    NULL, *condmedian = NULL;
  int IMPROVED = TRUE;
  int ncount;
  int relabel = 0;

#ifdef DEBUG
  fprintf (outfile, "before assigning condnodes\n");
  printedgescores (tree);
#endif
  if (COND)
    {
      ncount = 2 * num_genomes;
      condnode1 = &tpool[ncount + 2];
      condnode1->genome = &labels[ncount + 2];
      condnode2 = &tpool[ncount + 3];
      condnode2->genome = &labels[ncount + 3];
      condnode3 = &tpool[ncount + 4];
      condnode3->genome = &labels[ncount + 4];
      condmedian = &tpool[ncount + 5];
      condmedian->genome = &labels[ncount + 5];
    }
#ifdef DEBUG
  fprintf (outfile, "after assigning condnodes\n");
  printedgescores (tree);
#endif

  while (IMPROVED)
    {
      IMPROVED = FALSE;
      init_change_bits (tree);
      dfs_label_tree (COND, tree, tree, &best_so_far, &IMPROVED,
		      num_genes, num_genomes, weights, &relabel, tspsolver,
		      thresh, adj_list, adj_pool, neighbors, stack,
		      incycle, outcycle, degree, otherEnd, edges, tpool,
		      labels, pred1 + num_genes, pred2 + num_genes,
		      picked + num_genes, decode,
		      /* the num_genes offsets to allow negative indexing */
		      condmedian, condnode1, condnode2, condnode3,
		      genes, CIRCULAR, distmethod, distmem, correction);
      leaf_tree (tree);		/* reset visited flag */
    }
//#ifdef PRINT
  printf ("\nrelabeled %d nodes, tree score: %d\n", relabel, best_so_far);
  /*toGestalt(tree, yum); */

//#endif
  return (best_so_far);
}

/* must define exactly one of PREORDER or POSTORDER --- NOT BOTH!!! */
#define POSTORDER
void
dfs_label_tree (int COND, struct tNode *root, struct tNode *tree_node,
		int *best_so_far, int *IMPROVED,
		int num_genes, int num_genomes,
		int **weights, int *relabel,
		int tspsolver, int thresh,
		struct adj_struct *adj_list, struct adj_struct *adj_pool,
		intpair_t * neighbors, int *stack, int *incycle,
		int *outcycle, int *degree, int *otherEnd, edge_t * edges,
		struct tNode *tpool, struct genome_struct *labels, int *pred,
		int *succ, int *code, int *decode,
		/* pred, succ, and code have middle ptrs! */
		struct tNode *condmedian, struct tNode *condnode1,
		struct tNode *condnode2, struct tNode *condnode3,
		char *genes, int CIRCULAR,
		int distmethod, distmem_t * distmem, int correction)
{
  int score = 0, delta = 0;
  int i;
  int realsolver;
  int tmpmedianlength;
  struct genome_struct *gen[3];
  int tmp_sc_parent = 0, tmp_sc_lChild = 0, tmp_sc_rChild = 0;
  if (tree_node == NULL)
    return;
#ifdef POSTORDER
  if (!tree_node->lChild->leaf)
    {
      dfs_label_tree (COND, root, tree_node->lChild, best_so_far, IMPROVED,
		      num_genes, num_genomes, weights, relabel, tspsolver,
		      thresh, adj_list, adj_pool, neighbors, stack,
		      incycle, outcycle, degree, otherEnd, edges, tpool,
		      labels, pred, succ, code, decode, condmedian,
		      condnode1, condnode2, condnode3, genes, CIRCULAR,
		      distmethod, distmem, correction);
    }
  if (tree_node->rChild)
    {
      if (!tree_node->rChild->leaf)
	{
	  dfs_label_tree (COND, root, tree_node->rChild, best_so_far,
			  IMPROVED, num_genes, num_genomes, weights,
			  relabel, tspsolver, thresh, adj_list, adj_pool,
			  neighbors, stack, incycle, outcycle, degree,
			  otherEnd, edges, tpool, labels, pred, succ, code,
			  decode, condmedian, condnode1, condnode2,
			  condnode3, genes, CIRCULAR, distmethod, distmem,
			  correction);
	}
    }
#endif
  if (tree_node->need_change > 0)
    {				/* internal node needs to be relabeled */
// printf("tmps = %d %d %d, olds = %d %d %d\n", tmp_sc_parent, tmp_sc_lChild, tmp_sc_rChild, *(tree_node->sc_parent), *(tree_node->sc_lChild), *(tree_node->sc_rChild));
      for (i = 0; i < tree_node->genome->num_chars; i++)
	{			/* save old label */
	  genes[i] = tree_node->genome->genes[i];
	}
      genes[i] = '\0';
      tmpmedianlength = tree_node->genome->num_chars;
      /* which solver to call? */
      /* force use of  bbtsp if problem is too small */
      realsolver = tspsolver;
      if ((num_genes <= thresh) && (tspsolver != TSP_COALESCED))
	realsolver = TSP_BBTSP;
// printf("tmps = %d %d %d, olds = %d %d %d\n", tmp_sc_parent, tmp_sc_lChild, tmp_sc_rChild, *(tree_node->sc_parent), *(tree_node->sc_lChild), *(tree_node->sc_rChild));
      switch (realsolver)
	{
	case TREE_ALIGNMENT:
	  gen[0] = tree_node->parent->genome;
	  gen[1] = tree_node->lChild->genome;
	  gen[2] = tree_node->rChild->genome;
	  //  cleanCell (scoreCell, gen[0], gen[1], gen[2]);

#ifdef M_debug
	  printf ("\nAlignment Input:\n");
	  printf ("%d %s, %d\n", tree_node->parent->tag,
		  gen[0]->genes, gen[0]->num_chars);
	  printf ("%d %s, %d\n", tree_node->lChild->tag,
		  gen[1]->genes, gen[1]->num_chars);
	  printf ("%d %s, %d\n", tree_node->rChild->tag,
		  gen[2]->genes, gen[2]->num_chars);
#endif
	  if (!HEUR)
	    {
	      m_length = 0;
	      AffineTAMSAscoreProMPAM (gen[0]->genes,
				       gen[1]->genes,
				       gen[2]->genes,
				       gen[0]->num_chars,
				       gen[1]->num_chars,
				       gen[2]->num_chars, costDist, -1, -1);
	      median3[m_length] = '\0';
	    }
	  else
	    {			/* heuristic median */
	      h_median (gen[0]->genes,
			gen[1]->genes,
			gen[2]->genes,
			gen[0]->num_chars, gen[1]->num_chars,
			gen[2]->num_chars, pairSpace, costDist);
	    }
	  tree_node->genome->num_chars = m_length;
	  for (i = 0; i < tree_node->genome->num_chars; i++)
	    tree_node->genome->genes[i] = median3[i];
	  tree_node->genome->genes[i] = '\0';
	  Aout[m_length] = '\0';
	  Bout[m_length] = '\0';
	  Cout[m_length] = '\0';
#ifdef M_debug
	  printf ("\nAlignment:\n");
	  printf ("%s\n", Aout);
	  printf ("%s\n", Bout);
	  printf ("%s\n", Cout);
	  printf ("%s\n", median3);
#endif
	  m_length = 0;
	  condenseGap (tree_node->genome->genes,
		       &tree_node->genome->num_chars);
	  break;
	}
      score += (LARGENUM * num_genes);
      tree_node->need_change = 0;

      /* now use TSP score to compare to Hamming distance along the three
         edges; for INV distance, compute it -- cannot mix the two!
         if no improvement, restore the old label and exit */
      switch (distmethod)
	{
	case DIST_AL:
	  /* new label, so we have to compute distances */
	  tmp_sc_parent =
	    bp_score (tree_node, tree_node->parent, num_genes,
		      CIRCULAR, distmethod, distmem, correction, num_genes);
	  tmp_sc_lChild =
	    bp_score (tree_node, tree_node->lChild, num_genes,
		      CIRCULAR, distmethod, distmem, correction, num_genes);
	  tmp_sc_rChild =
	    bp_score (tree_node, tree_node->rChild, num_genes,
		      CIRCULAR, distmethod, distmem, correction, num_genes);
	  delta =
	    (tmp_sc_parent + tmp_sc_lChild + tmp_sc_rChild) -
	    (*(tree_node->sc_parent) + *(tree_node->sc_lChild) +
	     *(tree_node->sc_rChild));
	  break;
	default:
	  break;
	}
      //  printf ("Delta=%d delta=%d\n", Delta, delta);
      if ((Delta == -1 && delta < 0) || (Delta == 1 && delta > 0))
	{
//        printf ("I need to improve Delta=%d delta=%d\n", Delta, delta);
	  /* accept the change */
	  if (tree_node->lChild->tag < 0)
	    tree_node->lChild->need_change = 1;
	  if (tree_node->rChild->tag < 0)
	    tree_node->rChild->need_change = 1;
	  if (tree_node->parent->tag < 0)
	    tree_node->parent->need_change = 1;
	  /* update the distances along the three edges (both ways) */
	  *(tree_node->sc_parent) = tmp_sc_parent;
	  *(tree_node->sc_lChild) = tmp_sc_lChild;
	  *(tree_node->sc_rChild) = tmp_sc_rChild;
	  /* get ready for next loop */
	  *IMPROVED = TRUE;
	  (*relabel)++;
	  *best_so_far += delta;
	}
      else
	{			/* restore old label */
	  for (i = 0; i < tmpmedianlength; i++)
	    {
	      tree_node->genome->genes[i] = genes[i];
	    }
	  tree_node->genome->num_chars = tmpmedianlength;
	}
      tree_node->leaf = TRUE;
    }				/* end processing internal node */

#ifdef PREORDER
  if (!tree_node->lChild->leaf)
    {
      dfs_label_tree (COND, root, tree_node->lChild, best_so_far, IMPROVED,
		      num_genes, num_genomes, weights, relabel, tspsolver,
		      thresh, adj_list, adj_pool, neighbors, stack,
		      incycle, outcycle, degree, otherEnd, edges, tpool,
		      labels, pred, succ, code, decode, condmedian,
		      condnode1, condnode2, condnode3, genes, CIRCULAR,
		      distmethod, distmem);
    }
  if (tree_node->rChild)
    if (!tree_node->rChild->leaf)
      {
	dfs_label_tree (COND, root, tree_node->rChild, best_so_far,
			IMPROVED, num_genes, num_genomes, weights,
			relabel, tspsolver, thresh, adj_list, adj_pool,
			neighbors, stack, incycle, outcycle, degree,
			otherEnd, edges, tpool, labels, pred, succ, code,
			decode, condmedian, condnode1, condnode2,
			condnode3, genes, CIRCULAR, distmethod, distmem);
      }
#endif
  return;
}

void
deep_copy (const struct tNode *tpool, struct tNode *deep_pool,
	   int NUM_GENOMES)
{
  int i, j;

  int ploc[100];
  int lloc[100];
  int rloc[100];
  // int shift = deep_pool - tpool;

  for (i = 0; i < 2 * NUM_GENOMES - 2; i++)
    {
      if (tpool[i].parent == NULL)
	ploc[i] = -1;
      else
	{
	  for (j = 0; j < 2 * NUM_GENOMES - 2; j++)
	    {
	      if (tpool[i].parent == &tpool[j])
		{
		  ploc[i] = j;
		  break;
		}
	    }
	  if (j == 2 * NUM_GENOMES - 2)
	    {
	      printf ("Hmm p\n");
	      exit (-1);
	    }
	}
      if (tpool[i].lChild == NULL)
	lloc[i] = -1;
      else
	{
	  for (j = 0; j < 2 * NUM_GENOMES - 2; j++)
	    {
	      if (tpool[i].lChild == &tpool[j])
		{
		  lloc[i] = j;
		  break;
		}
	    }
	  if (j == 2 * NUM_GENOMES - 2)
	    {
	      printf ("Hmm l\n");
	      exit (-1);
	    }
	}
      if (tpool[i].rChild == NULL)
	rloc[i] = -1;
      else
	{
	  for (j = 0; j < 2 * NUM_GENOMES - 2; j++)
	    {
	      if (tpool[i].rChild == &tpool[j])
		{
		  rloc[i] = j;
		  break;
		}
	    }
	  if (j == 2 * NUM_GENOMES - 2)
	    {
	      printf ("Hmm r\n");
	      exit (-1);
	    }
	}

    }

  /*  for (i = 0; i < 2*NUM_GENOMES-1; i++) printf("%p %p %p %p\n", &tpool[i],
     tpool[i].parent, tpool[i].lChild, tpool[i].rChild); */
  for (i = 0; i < 2 * NUM_GENOMES - 2; i++)
    {
      if (tpool[i].valid == 0)
	printf ("not valid %d\n", i);
      deep_pool[i].sc_parent = NULL;
      deep_pool[i].sc_lChild = NULL;
      deep_pool[i].sc_rChild = NULL;
      if (ploc[i] == -1)
	deep_pool[i].parent = NULL;
      else
	deep_pool[i].parent = &deep_pool[ploc[i]];
      if (lloc[i] == -1)
	deep_pool[i].lChild = NULL;
      else
	deep_pool[i].lChild = &deep_pool[lloc[i]];
      if (rloc[i] == -1)
	deep_pool[i].rChild = NULL;
      else
	deep_pool[i].rChild = &deep_pool[rloc[i]];
      deep_pool[i].genome = NULL;
      deep_pool[i].tag = tpool[i].tag;
      deep_pool[i].leaf = tpool[i].leaf;
    }
}

int
score_tree (struct tNode *treeNode, int num_genes, int CIRCULAR,
	    int distmethod, distmem_t * distmem, int correction)
{
  int score = 0;
  if (treeNode == NULL)
    return 0;
  if (treeNode->lChild)
    {
      *(treeNode->lChild->sc_parent) = *(treeNode->sc_lChild) =
	bp_score (treeNode, treeNode->lChild, num_genes, CIRCULAR,
		  distmethod, distmem, correction, num_genes);
      score += *(treeNode->sc_lChild) +
	score_tree (treeNode->lChild, num_genes, CIRCULAR, distmethod,
		    distmem, correction);
    }
  if (treeNode->rChild)
    {
      *(treeNode->rChild->sc_parent) = *(treeNode->sc_rChild) =
	bp_score (treeNode, treeNode->rChild, num_genes, CIRCULAR,
		  distmethod, distmem, correction, num_genes);
      score += *(treeNode->sc_rChild) +
	score_tree (treeNode->rChild, num_genes, CIRCULAR, distmethod,
		    distmem, correction);
    }
  return score;
}

void
new_score (char **seqs, int NUM_GENOMES, int **cost)
{
  int i;
  if (seqs == NULL)
    return;
  for (i = 1; i < 2 * NUM_GENOMES - 2; i++)
    {
      //  printf("current tree score %d, add this edge %d, ", scan_score, i);
      scan_score += scan_pair (&seqs[seqs[i][19]][20], &seqs[i][20], cost);
      // printf("after score is %d.\n", scan_score);
    }

}

void
setSeqs (struct tNode *treeNode, char **seqs, int NUM_GENOMES, int parent)
{
  /* Use seqs[i][0-16] store the current node's name 
   * Use seqs[i][17] store the current node's tag
   * Use seqs[i][18] store the current node's parent's tag
   * Use seqs[i][19] store the current node's parent's order in seqs
   * Use &seqs[i][20] store the current node's sequences 
   */
  int i, p = row;
  if (treeNode == NULL)
    return;
  if (treeNode->genome->genome_num > 0)
    {
      for (i = 0; i < 17; i++)
	{
	  seqs[row][i] = treeNode->genome->gnamePtr[i];
	}
    }
  seqs[row][17] = treeNode->tag;
  seqs[row][19] = parent;
  for (i = 20; i < treeNode->genome->num_chars + 20; i++)
    seqs[row][i] = treeNode->genome->genes[i - 20];
  seqs[row][i] = '\0';		//ending the string.
  if (treeNode->parent != NULL)
    {
      seqs[row][18] = treeNode->parent->tag;
#ifdef checkSeq
      printf ("Adding node ID %d to row %d, parent is %d. \n",
	      treeNode->genome->genome_num, row,
	      treeNode->parent->genome->genome_num);
#endif
    }
  else
    {
      seqs[row][18] = 0;
#ifdef checkSeq
      printf ("Adding node ID %d to %d, this is the tree root. \n",
	      treeNode->genome->genome_num, row);
#endif
    }
  row++;
  if (treeNode->lChild)
    {
      setSeqs (treeNode->lChild, seqs, NUM_GENOMES, p);
    }
  if (treeNode->rChild)
    {
      setSeqs (treeNode->rChild, seqs, NUM_GENOMES, p);
    }
}

void
alignSeqs (char **seqs, int NUM_GENOMES, int order)
{
  int i, j, k, lenA, lenB;
  int rowNum, loopUp, min, score;
  // PAoutput = 1;
#ifdef checkSeq
  for (i = 0; i < 2 * NUM_GENOMES - 2; i++)
    {
      printf ("%2d ", seqs[i][17]);
      printf ("%2d ", seqs[i][18]);
      printf ("%2d ", seqs[i][19]);
      printf ("%2d ", strlen (&seqs[i][20]));
      printf ("%2d: %s\n", i, &seqs[i][20]);
    }
#endif
  /* start from 1, because 0 is the root. */
  for (i = 1; i < 2 * NUM_GENOMES - 2; i++)
    {
      if (DOOLITTLE)
	{
	  min = 9999;
	  for (rowNum = 0; rowNum < i; rowNum++)
	    {
	      lenA = strlen (&seqs[rowNum][20]);
	      lenB = strlen (&seqs[i][20]);
	      score =
		pairscore (&seqs[rowNum][20], &seqs[i][20], lenA, lenB, aa,
			   bb, AA, BB, pairSpace, costDist);
	      if (score < min)
		{
		  loopUp = rowNum;
		  min = score;
		}
	    }
	  /* Now we know who is closest to current node , align them */
#ifdef checkSeq
	  printf ("\nBest pair %d,%d\n", i, loopUp);
	  printf ("%s\n%s\n", &seqs[loopUp][20], &seqs[i][20]);
#endif
	  PAoutput = 1;
	  score = pairscore (&seqs[loopUp][20], &seqs[i][20],
			     strlen (&seqs[loopUp][20]), lenB, aa, bb, AA, BB,
			     pairSpace, costDist);
	  PAoutput = 0;
	}
      else
	{
	  PAoutput = 1;
	//  printf ("align %d, %d.\n%s\n%s\n", seqs[i][19], i, &seqs[seqs[i][19]][20], &seqs[i][20]);
	  score = pairscore (&seqs[seqs[i][19]][20], &seqs[i][20],
			     strlen (&seqs[seqs[i][19]][20]), strlen(&seqs[i][20]), aa, bb,
			     AA, BB, pairSpace, costDist);
	  PAoutput = 0;
	}
      /* gapPos is an array to store all the gap happened above
       * insert gap in all aligned sequences */
      k = 0;
      while (gapPos[k] != -1)
	{
	  for (j = 0; j < i; j++)
	    {
	      if (DOOLITTLE)
		{
		  if (j != loopUp
		      && strlen (&seqs[i][20]) != strlen (&seqs[j][20]))
		    shiftString (&seqs[j][20], gapPos[k]);
		}
	      else
		{
		  if (j != seqs[i][19]
		      && strlen (&seqs[i][20]) != strlen (&seqs[j][20]))
		    shiftString (&seqs[j][20], gapPos[k]);
		}
	    }
	  k++;
	}
    }
  /* replace X with ., for MSF format output */
  for (i = 0; i < 2 * NUM_GENOMES - 2; i++)
    {
      for (j = 20; j < strlen (&seqs[i][20]) + 20; j++)
	{
	  if (seqs[i][j] == 'X')
	    seqs[i][j] = '.';
	}
    }
  if (order == 1)
    printAlignedSeqs (seqs, NUM_GENOMES);
  row = 0;			//reset row number for next tree

}

void
printAlignedSeqs (char **seqs, int NUM_GENOMES)
{
  /* print out result in MSF format,
   * Loop to check how many rows.
   * but need to shuffle ** seqs ???
   */
  int i, j, k, l, loop;
  char *tmp;

  printf ("\nOverall alignment in tree node order: \n");
  for (i = 0; i < 2 * NUM_GENOMES - 2; i++)
    {
      printf ("Node %4d: %s\n", seqs[i][17], &seqs[i][20]);
    }
  for (i = 1; i < NUM_GENOMES + 1; i++)
    {
      for (j = i - 1; j < 2 * NUM_GENOMES - 2; j++)
	{
	  if (seqs[j][17] == i)
	    {
	      tmp = seqs[i - 1];
	      seqs[i - 1] = seqs[j];
	      seqs[j] = tmp;
	      break;
	    }
	}
    }
  /* OK, now the seqs has been sorted in the input order,
   * ready to print out the answer in MSF format!
   */

  printf ("\nLen: %4d\n", strlen (&seqs[0][20]));
  printf ("\n//\n\n");
  loop = strlen (&seqs[0][20]) / 50 + 1;
  for (j = 0; j < loop; j++)
    {
      for (i = 0; i < NUM_GENOMES; i++)
	{
	  printf ("%-12s", seqs[i]);
	  for (l = 0; l < 5; l++)
	    {
	      for (k = 0; k < 10; k++)
		{
		  if (j * 50 + 20 + l * 10 + k < strlen (&seqs[0][20]) + 20)
		    printf ("%c", seqs[i][j * 50 + 20 + l * 10 + k]);
		}
	      printf (" ");
	    }
	  printf ("\n");
	}
      printf ("\n");
      printf ("\n");
    }

}

void
shiftString (char *seq, int pos)
{
  int i, len;
  char tmp = seq[pos];
  char tmp2;
  //printf("Input:  %s.\n", seq);
  len = strlen (seq);
  seq[pos] = 'X';

  for (i = pos + 1; i <= len; i++)
    {
      tmp2 = seq[i];
      seq[i] = tmp;
      tmp = tmp2;
    }
  seq[i] = '\0';
  // printf("Output: %s.\n", seq);
}

int
bp_score (struct tNode *node1, struct tNode *node2, int num_genes,
	  int CIRCULAR, int distmethod, distmem_t * distmem, int correction,
	  int oldngenes)
{
  int dist, X, Y;
//  int i;

  if (node1 == NULL || node2 == NULL)
    return 0;
  switch (distmethod)
    {
    case DIST_AL:
      X = node1->genome->num_chars;
      Y = node2->genome->num_chars;
      dist =
	pairscore (node1->genome->genes, node2->genome->genes, X, Y, aa, bb,
		   AA, BB, pairSpace, costDist);
      break;
    default:
      dist = -1;
      fprintf (stderr, "ERROR: Bad distance method in bp_score()\n");
    }
  return (dist);
}


/* Use genome_list to initialize genome pointers in the leaves of the
   tree.
*/
void
add_genomes_to_tree (struct tNode *treeNode, struct genome_struct *labels,
		     struct genome_struct *genome_list, int num_genes)
{
  int i, id;
  struct genome_struct *gen;

  if (treeNode == NULL)
    return;
  if (treeNode->leaf == TRUE)
    {
      /* because this is a leaf, the treeNode->tag is non-negative */
      /* no need for malloc: just index into the labels array */
      id = treeNode->tag;
      gen = treeNode->genome = &labels[id];
      gen->genome_num = id;	/* not really redundant -- flags it as leaf */
      id--;
      for (i = 0; i < genome_list[id].num_chars; i++)
	/* Be carefule about this */
	{
	  gen->genes[i] = genome_list[id].genes[i];
	}
      /*added for MPME */
      /*end MPME */
      gen->gnamePtr = genome_list[id].gnamePtr;
      gen->num_chars = genome_list[id].num_chars;
    }
  add_genomes_to_tree (treeNode->lChild, labels, genome_list, num_genes);
  add_genomes_to_tree (treeNode->rChild, labels, genome_list, num_genes);
  return;
}

void
restore_genome ()
{
}

void
label_node (struct tNode *tree_node, struct tNode *new_node, int num_genes)
{
}

void
leaf_tree (struct tNode *tree)
{
  if (tree == NULL)
    return;
  if (tree->tag < 0)
    tree->leaf = FALSE;
  leaf_tree (tree->lChild);
  leaf_tree (tree->rChild);
  return;
}

void
init_change_bits (struct tNode *tree)
{
  if (tree == NULL)
    return;
  if (tree->tag < 0)
    {				/* internal node */
      tree->need_change = 1;
    }
  else
    {				/* leaf: labels are permanent */
      tree->need_change = 0;
    }
  init_change_bits (tree->lChild);
  init_change_bits (tree->rChild);
  return;
}


void
TBR (struct tNode *tree, struct tNode *tpool, int num_genomes)
{
  int npos, epos, i;		/* n the cut, e the add */

  struct tNode *nparent;
  struct tNode *eparent;
  char tmp[128];

  for (i = 0; i < 2 * num_genomes + 6; i++)
    tpool[i].valid = 0;
  checkArray (&tpool[0]);

  npos = 1 + rand () % (2 * num_genomes - 4);	/* should be 1+... */
  epos = 1 + rand () % (2 * num_genomes - 4);
  while (!validEdge (tpool, npos, epos))
    {
      npos = 1 + rand () % (2 * num_genomes - 4);
      epos = 1 + rand () % (2 * num_genomes - 4);
    }

  printf ("%d %d\n", npos, epos);

  //npos = 5; epos = 4;
/*  if (npos == 6)
    {
      printf ("6's tag is %d, has a parent of %d\n", tpool[npos].tag,
	      tpool[npos].parent->tag);
    }
*/
  nparent = tpool[npos].parent;
  eparent = tpool[epos].parent;
/*
    printf("n=%p  np=%p         e=%p  ep=%p\n", &tpool[npos], nparent,
            &tpool[epos], eparent);

    printf("npl=%p npr=%p       epl=%p epr=%p\n",
            nparent->lChild, nparent->rChild,
            eparent->lChild, eparent->rChild);
    printf("nl=%p nr=%p         el=%p er=%p\n",
            tpool[npos].lChild, tpool[npos].rChild,
            tpool[epos].lChild, tpool[epos].rChild);

    printf("npp=%p epp=%p\n",
            nparent==NULL?NULL:nparent->parent, 
            eparent==NULL?NULL:eparent->parent);
            */
  if (nparent->parent == NULL)
    {				/* cut under root */

    }
  else if (nparent->parent->lChild == nparent)
    {
      /* is left child of parent */
      if (nparent->lChild == &tpool[npos])
	{
	  nparent->parent->lChild = nparent->rChild;
	  nparent->rChild->parent = nparent->parent;
	}
      else
	{
	  nparent->parent->lChild = nparent->lChild;
	  nparent->lChild->parent = nparent->parent;
	}
    }
  else if (nparent->parent->rChild == nparent)
    {
      if (nparent->lChild == &tpool[npos])
	{
	  nparent->parent->rChild = nparent->rChild;
	  nparent->rChild->parent = nparent->parent;
	}
      else
	{
	  nparent->parent->rChild = nparent->lChild;
	  nparent->lChild->parent = nparent->parent;
	}
    }
  else
    {
      printf ("You should not be here\n");
      exit (-1);

    }

  nparent->rChild = &tpool[npos];	/* make sure the node is the right */

  if (eparent == NULL)
    {
      eparent->lChild = nparent;
      printf ("Error\n");
      exit (-1);
    }
  else if (eparent->lChild == &tpool[epos])
    {
      eparent->lChild = nparent;
    }
  else if (eparent->rChild == &tpool[epos])
    eparent->rChild = nparent;
  else
    {
      printf ("You should not be here 2\n");
      exit (-1);
    }
  nparent->parent = eparent;
  nparent->lChild = &tpool[epos];
  tpool[epos].parent = nparent;

  print_tree_nexus_noscore (tmp, tree);
  printf ("New TBR tree is %s\n", tmp);
  return;


}

int
validEdge (struct tNode *tpool, int npos, int epos)
{
  struct tNode *p;
  if (tpool[epos].valid == 0 || tpool[npos].valid == 0)
    {
      printf ("%d %d\n", epos, npos);
      exit (-1);
    }
  if (epos == npos || tpool[npos].parent->parent == NULL ||
      tpool[npos].parent == &tpool[epos]
      || tpool[epos].parent == &tpool[npos]
      || tpool[epos].parent == tpool[npos].parent
      || tpool[epos].valid == 0 || tpool[npos].valid == 0)
    return 0;

  /* we don't want epos be a subtree of npos */
  p = tpool[epos].parent;
  while (p != NULL)
    {
      if (p == &tpool[npos])
	return 0;
      p = p->parent;
    }

  return 1;
}

int
checkArray (struct tNode *tree)
{
  if (tree == NULL)
    return 0;
  tree->valid = 1;
  if (tree->lChild != NULL)
    checkArray (tree->lChild);
  if (tree->rChild != NULL)
    checkArray (tree->rChild);
}

void
clearTag (struct tNode *tree, int *index)
{
  if (tree->tag > 0)
    return;
  (*index) -= 1;
  tree->tag = (*index);
  if (tree->lChild != NULL)
    {
      clearTag (tree->lChild, index);
    }
  if (tree->rChild != NULL)
    {
      clearTag (tree->rChild, index);
    }
}

void
printTag (struct tNode *tree)
{
  if (tree == NULL)
    return;
  printf ("node %3d p=%3d l=%3d r=%3d\n", tree->tag,
	  tree->parent != NULL ? tree->parent->tag : 0,
	  tree->lChild != NULL ? tree->lChild->tag : 0,
	  tree->rChild != NULL ? tree->rChild->tag : 0);
  if (tree->lChild != NULL)
    {
      printTag (tree->lChild);
    }
  if (tree->rChild != NULL)
    {
      printTag (tree->rChild);
    }
}
